/************************************************************
 * File BarCodeReader.c
 *
 * Project: Access control FACIN Jornada Academica 2008/2
 *
 * Author: Eduardo Augusto Bezerra
 * Date: 11/08/2008
 * 
 * Last change: Eduardo Augusto Bezerra
 * Date: 25/08/2008
 *
 * Functions for RS-232C serial port management (config, read bar code , ...)
 * 
 *************************************************************/

int  fd;            // handle to serial port (fd == -1, error!)

/************************************************************
 * void openSerial(int ser)
 *
 * open the serial connection;
 * sets the serial parameters to 9600 Baud, no parity, 8, 1;
 * and turns all motors off
 *
 *************************************************************/
void openSerial(int ser){
   char serial[11];    // serial port name (e.g. /dev/ttyS0, ...)
   // serial names
   char *com1="/dev/ttyS0", *com2="/dev/ttyS1", 
        *com3="/dev/ttyS2", *com4="/dev/ttyS3";

   struct termios options;

   switch(ser) {
        case 1: strcpy(serial,com1);
                break;
        case 2: strcpy(serial,com2);
                break;
        case 3: strcpy(serial,com3);
                break;
        case 4: strcpy(serial,com4);
                break;
        default: { printf("Error! valid ports are 1, 2, 3 and 4. ");
                   printf("Will try to open port 1.\n");
                 }
      }

   fd = open(serial, O_RDWR|O_NOCTTY|O_NDELAY);
   if (fd == -1)      // ERROR!!
      printf("Error opening %s \n", serial);
   else
      fcntl(fd, F_SETFL, 0);
   printf("Serial port in use: %s \n\n", serial);

   // Program serial port to 9600, 8, 1, no parity
   //

   // Get the current options for the port
   tcgetattr(fd, &options);

   // Set the baud rate to 9600
   cfsetispeed(&options, B9600);
   cfsetospeed(&options, B9600);

   // Enable the receiver and set local mode
   options.c_cflag |= (CLOCAL | CREAD);

   // Setting parity checking (no parity) 8N1
   options.c_cflag &= ~PARENB;        /* no parity */
   options.c_cflag &= ~CSTOPB;        /* 1 stop bit */
   options.c_cflag &= ~CSIZE;         /* Mask the character size bits */
   options.c_cflag |= CS8;            /* Select 8 data bits */
   
   // Setting raw input
   options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);

   // Setting raw output
   options.c_oflag &= ~OPOST;

   // Set the new options for the port
   tcsetattr(fd, TCSANOW, &options);

}




