//
// "$Id: hello.cxx 6118 2008-04-24 09:10:22Z matt $"
//
// Hello, World! program for the Fast Light Tool Kit (FLTK).
//
// Copyright 1998-2005 by Bill Spitzak and others.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.
//
// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
//
// Please report all bugs and problems on the following page:
//
//     http://www.fltk.org/str.php
//

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Output.H>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <time.h>

#include "BarCodeReader.c"

int main(int argc, char **argv) {
   char tecla;
   int i=0, result;
   char matricula[12];
   time_t     now;
   struct tm  ts;
   char       buf[80];

   FILE *fp;
/*
Fl_Output *text;
Fl_Window *window;

  window = new Fl_Window(400,400);

  text = new Fl_Output(100,280,200,30,"Fl_Output");
  text->value("teste");
  text->align(FL_ALIGN_BOTTOM);
  text->tooltip("This is an Fl_Output widget.");

  //window->forms_end();
  window->show(argc,argv);
  Fl::run();
*/

   openSerial(1);

   fp=fopen ("freq_2008_2.txt","a+");

   if (!fp) {
        printf ("Erro na abertura do arquivo.");
        return 0;
   }


  Fl_Window *window = new Fl_Window(300,180);
  Fl_Box *box = new Fl_Box(FL_NO_BOX,20,40,260,100,"Jornada 2008");
  box->labelfont(FL_BOLD+FL_ITALIC);
  box->labelsize(36);
  box->labeltype(FL_SHADOW_LABEL);
  window->end();
  window->show(argc, argv);
  //Fl::run();



   fcntl(fd, F_SETFL, 0);


   while (1) {
     
      i = 0;
      while(read(fd, &tecla, 1) > 0){    // leitura de um byte por vez da serial
         matricula[i] = tecla;
         if (tecla == '\n'){                   // os crachas da PUC possuem 10 caracteres
            i = 0;
            time(&now);
            ts = *localtime(&now);
            // Formata e imprime o tempo, "ddd yyyy-mm-dd hh:mm:ss zzz"
            // strftime(buf, sizeof(buf), "%a %Y-%m-%d %H:%M:%S %Z", &ts);
            strftime(buf, sizeof(buf), "%d-%m-%Y %H:%M:%S", &ts);
            printf("=>%s %s", buf, matricula);
            box->label(matricula);
            box->redraw();

            // BUG!
            Fl::wait();

            result = fprintf(fp, "=>%s %s", buf, matricula);
            fflush(fp);
            memset(matricula,0, sizeof(matricula));
            printf("\nFavor passar o cartao na leitora de codigo de barras: \n");
         } else
            i++;
      }
      printf("saiu\n\n");
      tecla=0;

   }
   close (fd);
   fclose (fp);
   return 0;

}


