/************************************************************
 * File main.c - 
 *
 * Project: Access control FACIN Jornada Academica 2008/2
 *
 * Author: Eduardo Augusto Bezerra
 * Date: 11/08/2008
 * 
 * Last change: Eduardo Augusto Bezerra
 * Date: 25/08/2008
 * 
 *************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <string.h>
#include <sys/types.h>
#include <sys/time.h>
#include <time.h>

#include "BarCodeReader.c"

int main(int argc, char **argv){
   char tecla;
   int i=0, result;
   char matricula[12];
   time_t     now;
   struct tm  ts;
   char       buf[80];

   FILE *fp;

   if(argc > 1){
      printf("Uso incorreto \n");
      return 1;
   }

   openSerial(1);

   fp=fopen ("freq_2008_2.txt","a+");
   if (!fp) {
        printf ("Erro na abertura do arquivo.");
        return 0;
   }

   printf("\nFavor passar o cartao na leitora de codigo de barras: \n");

/* Essas chamadas fazem ler imediatamante mesmo que não tenha nenhum dado transmitido*/
 //           fcntl(fd, F_SETFL, FNDELAY);
   fcntl(fd, F_SETFL, 0);
   for (;;) {
      memset(matricula,0, sizeof(matricula));
      i = 0;
      while(read(fd, &tecla, 1) > 0){    // leitura de um byte por vez da serial
         matricula[i] = tecla;
         if (tecla == '\n'){                   // os crachas da PUC possuem 10 caracteres
            i = 0;
            time(&now);
            // Formata e imprime o tempo, "ddd yyyy-mm-dd hh:mm:ss zzz"
            ts = *localtime(&now);
            // strftime(buf, sizeof(buf), "%a %Y-%m-%d %H:%M:%S %Z", &ts);
            strftime(buf, sizeof(buf), "%d-%m-%Y %H:%M:%S", &ts);
            printf("=>%s %s", buf, matricula);
            result = fprintf(fp, "=>%s %s", buf, matricula);
            fflush(fp);
            memset(matricula,0, sizeof(matricula));
            printf("\nFavor passar o cartao na leitora de codigo de barras: \n");
         } else
            i++;
      }
      printf("saiu\n\n");
      tecla=0;

   }

   close (fd);
   fclose (fp);
   return 0;
}


